var _this = this;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

import isAbsoluteUrl from 'axios/lib/helpers/isAbsoluteURL';

var responseTypes = ['arraybuffer', 'blob', 'formData', 'json', 'text'];

var prepareSuccessPayload = function prepareSuccessPayload(response, _ref) {
  var _ref$responseType = _ref.responseType,
      responseType = _ref$responseType === undefined ? 'json' : _ref$responseType;

  if (responseTypes.indexOf(responseType) === -1) {
    throw new Error("responseType must be one of the following: 'arraybuffer', 'blob', 'formData', 'json', 'text'");
  }

  return response[responseType]();
};

var getSuccessPayload = function getSuccessPayload(response, request) {
  if (Array.isArray(response)) {
    return Promise.all(response.map(function (responseItem, i) {
      return prepareSuccessPayload(responseItem, request[i]);
    }));
  }

  return prepareSuccessPayload(response, request);
};

var getErrorPayload = function getErrorPayload(error) {
  return error;
};

var getRequestHandlers = function getRequestHandlers(requestInstance) {
  var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref2$baseURL = _ref2.baseURL,
      baseURL = _ref2$baseURL === undefined ? '' : _ref2$baseURL;

  var sendRequestSaga = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref4) {
      var url = _ref4.url,
          requestConfig = _objectWithoutProperties(_ref4, ['url']);

      var response;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return requestInstance(isAbsoluteUrl(url) ? url : baseURL + url, requestConfig);

            case 2:
              response = _context.sent;

              if (response.ok) {
                _context.next = 5;
                break;
              }

              throw response;

            case 5:
              return _context.abrupt('return', response);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this);
    }));

    return function sendRequestSaga(_x2) {
      return _ref3.apply(this, arguments);
    };
  }();

  return { sendRequest: sendRequestSaga };
};

var fetchApiDriver = {
  getSuccessPayload: getSuccessPayload,
  getErrorPayload: getErrorPayload,
  getRequestHandlers: getRequestHandlers
};

export default fetchApiDriver;